
//Define pin constants
const int sense0 = 14;
const int sense1 = 15;
const int sense2 = 16;
const int sense3 = 17;
const int closecheck = 18;
const int opencheck = 19;

//Carousel Control
const int motor0 = 10;
const int motor1 = 11;

//Define variables
int Sensor0 = 0;
int Sensor1 = 0;
int Sensor2 = 0;
int Sensor3 = 0;
int TrayStatus = 0;

int g = 0; // General purpose register
int h = 0;

void setup() {                
  Serial.begin(9600);
  
  pinMode(sense0, INPUT);
  pinMode(sense1, INPUT);
  pinMode(sense2, INPUT);
  pinMode(sense3, INPUT);
  
  pinMode(motor0, OUTPUT);
  pinMode(motor1, OUTPUT); 
  
}

void loop() {
  
  clockwise(200);
  delay(200);
  brake();
  delay(1000);
  
  //loaddisc();
  //delay(1000);
  //unloaddisc();
  //delay(1000);
  
  //unloaddisc();
  //delay(1000);
  //counterclockwise(200);
  //delay(1000);

}


void nextdisc() {


  discsensor();
  while(Sensor2 == 1){ //Wait for fine sensor to clear...
    clockwise(200);
    discsensor();
}  
  

  while(Sensor3 == 0){ //Wait for fine sensor to clear...
    clockwise(100); //Slow it down even more...
    discsensor();
}

  brake(); // Stop movement.
  delay(100);
  counterclockwise(125);
  delay(125);
  brake();


}  
  



void clockwise(int speedx) {
  digitalWrite(motor0, 0);
  analogWrite(motor1, speedx);
}

void counterclockwise(int speedx) {
  digitalWrite(motor1, 0);
  analogWrite(motor0, speedx);
}

void brake() {
  digitalWrite(motor0, 1);
  digitalWrite(motor1, 1);
  delay(10);
  digitalWrite(motor0, 0);
  digitalWrite(motor0, 0);
}  


void discsensor() {
  Sensor0 = digitalRead(sense0);
  Sensor1 = digitalRead(sense1);
  Sensor2 = digitalRead(sense2);
  Sensor3 = digitalRead(sense3);
  
  GetTrayStatus();
  
  Serial.print(Sensor0, DEC);
  Serial.print(" ");
  Serial.print(Sensor1, DEC);
  Serial.print(" ");
  Serial.print(Sensor2, DEC);
  Serial.print("   DISC:");
  Serial.print(Sensor3, DEC);
  Serial.print(" TRAY:"); 
  Serial.print(TrayStatus, DEC);    
  
  Serial.println();
}


void GetTrayStatus() {
  
  
  g = digitalRead(opencheck);
  h = digitalRead(closecheck);

  if (g == 0) {
  TrayStatus = 0; //Closed
  }

  if (h == 0) {
  TrayStatus = 1; //Open
  }  

  if (h == 1) {
    if (g == 1) {
      TrayStatus = 9;
    }
  }

}



